//*************************************************************************
//  d͌vQ̃\tg
//*************************************************************************

#include "msp430x42x0.h"
#include "power2.h"
#include <math.h>
#include <stdlib.h>
#include <stdio.h>


void  t1ms(unsigned short dat);         // dat msԑ҂,Basic Timer1g
void  LCD_INIT(void);                   // LCDӼޭق̏
void  OUTLCDH(unsigned char dat);       // LCD̃ju[hł̏
void  OUTLCDC(unsigned char dat);       // ݽ׸ݥڼ޽ւ̏
void  OUTLCDD(unsigned char dat);       // ްڼ޽ւ̏
void  t50us(void);                      // 50umsԑ҂
void  HOME_LCD(void);                   // J[\1sڐ擪
void  HOME2_LCD(void);                  // J[\2sڐ擪
long  disp_d(long dat, long num);       // datnumڂ\
int   i;                                // ėp
int   f_0;                              // ׸, 0ϐ(0\LŎgp)
int   f_iv;                             // 胂[hptO
int   ad_dat[64];                       // ADϊp
int   idx;                              // ADϊ̃CfbNX
float psum;                             // d͂̐Ϙal
float isum;                             // d̐Ϙal
float vsum;                             // d̐Ϙal
int   tmp;                              // ADϊ̈ꎞgp̕ϐ
float pow0;                             // Ld
float pmax;                             // őud
float ptmp;                             // ͗
long  temp;                             // LCD\ɈꎞIɎgp
float irms;                             // d̎l
float vrms;                             // d̎l
char  pt;                               // g`̈ʒu
char  angle;                            // ʑ

void main(void)
{
  WDTCTL = WDTPW + WDTHOLD;             // WDT̒~
  SCFQCTL = 75 - 1;                     // MCLK = 75 * ACLK * 2 = 4.9152MHz, D = 2
  FLL_CTL0 = DCOPLUS + XCAP18PF;        // DCOPLUS = 1, eʕׂ18pF
  SCFI0 = FLLD_2 + FN_2;                // D = 2, fDCOCLK =   2.2-17Mhz

  BTCTL = BT_ADLY_2000;                 // Basic Timer̃NbNACLK/256

  P5DIR |= 0xe0;                        // P5 o for LCD_E, RW, RS
  P2DIR |= 0xf0;                        // P2_7,6,5,4 o for LCD_DB
  P2IE |= 0x1;                          // P2.0 interrupt enabled
  P2IES |= 0x1;                         // P2.0 Hi/lo edge
  P2IFG &= ~0x1;                        // P2.0 IFG cleared
  P2DIR |= 0x2;                         // P2.1 Output

  LCD_RW = 0;
  LCD_RS = 0;
  LCD_E = 0;
  LCD_INIT();                           // LCD̏


  P6SEL |= 0xf;                         // A0+-, A1+- ̐ݒ
  SD16CTL = SD16VMIDON + SD16REFON + SD16SSEL_1 + SD16DIV_1 + SD16XDIV_1; //
      // VMID I, 1.2V refI, SMCLK, /2, /3  fM = 4.9152MHz / 2 / 3 = 819.2kHz
  t1ms(1);                              // 1ms҂FVref[q̃RfT[d҂
  SD16CCTL0 = SD16IE + SD16DF + SD16OSR_256; // OSR=1024, oC|[
  t1ms(100);                            // 肷܂100ms҂
  SD16INCTL0 = SD16INTDLY_0 + SD16GAIN_1 + SD16INCH_1;
      // 4ڂ犄, PGA̗1, `lA1

  _BIS_SR(GIE);                         // ݉

  while(1)
  {
    if (f_iv == 2)                      // ADTvOI?
    {
      pow0 = psum / 1.071e7;            // d͂̌vZ
      irms = (sqrt(isum) - 120) / 8374; // dľvZ
      if (irms < 0) irms = 0;           // d̏ꍇ̓[
      vrms = sqrt(vsum) / 1253;         // dľvZ
      ptmp = pow0 / irms / vrms;        // Ld́^瑊d
      if (ptmp > 1) ptmp = 1;
      angle = acos(ptmp) * 180. / 3.1415; // ʑp̌vZ
      HOME_LCD();                       // 1sڂ̐擪d͂\
      OUTLCDD('P');
      OUTLCDD('=');
      temp = labs(pow0 * 10);
      temp = disp_d(temp, 10000);
      temp = disp_d(temp, 1000);
      temp = disp_d(temp, 100);
      temp = disp_d(temp, 10);
      OUTLCDD('.');
      temp = disp_d(temp, 1);
      OUTLCDD('W');

      OUTLCDD(' ');
      OUTLCDD(0xf2);                    // ʑ̕\
      OUTLCDD('=');
      if (pt > 14)                      // pt̑傫ňʑ̐𔻒
      {
        OUTLCDD('-');
      }
      else
      {
        OUTLCDD(' ');
      }
      temp = angle;
      temp = disp_d(temp, 10);
      temp = disp_d(temp, 1);
      OUTLCDD(0xdf);

      HOME2_LCD();                      // 2sڂ̐擪d\
      OUTLCDD('I');
      OUTLCDD('=');
      temp = irms * 1000;
      temp = disp_d(temp, 10000);
      temp = disp_d(temp, 1000);
      OUTLCDD('.');
      temp = disp_d(temp, 100);
      temp = disp_d(temp, 10);
      temp = disp_d(temp, 1);
      OUTLCDD('A');

      OUTLCDD(' ');
      temp = vrms * 10;                 // d\
      temp = disp_d(temp, 1000);
      temp = disp_d(temp, 100);
      temp = disp_d(temp, 10);
      OUTLCDD('.');
      temp = disp_d(temp, 1);
      OUTLCDD('V');
      isum = 0;                         // eϐNAÃTvOɔ
      vsum = 0;
      f_iv = 0;
      idx = 0;
    }
  }
}

#pragma vector=SD16_VECTOR
__interrupt void SD16ISR(void)
{
  if (f_iv == 0)
  {
    tmp = - SD16MEM0;                   // ADϊf[^ad_datzϐ
    ad_dat[idx] = tmp;
    vsum += pow(tmp, 2);                // ADϊf[^2vsumɐώZ
    idx++;
    if (idx >= 64)                      // TvOIH
    {
      SD16CCTL0 &= ~SD16SC;             // ADϊ~
      SD16INCTL0 = SD16INTDLY_0 + SD16GAIN_1 + SD16INCH_0; // ̓`ld
      idx = 0;
      f_iv = 1;                         // 胂[hACI
      psum = 0;                         // psumNA
      pmax = 0;                         // pmaxNA
      P2IFG &= ~0x1;                    // P2.0 IFG cleared
    }
  }
  else
  {
    tmp = SD16MEM0;                     // ADϊf[^ad_datZud͂vZ
    ptmp = (float)ad_dat[idx] * tmp;
    psum += ptmp;                       // ud͂psumɐώZ
    isum += pow(tmp, 2);                // ADϊf[^2isumɐώZ
    if (ptmp > pmax)                    // őud͂XVꂽ
    {
      pmax = ptmp;                      // pmax̍XV
      if (idx <= 30) pt = idx;          // TvOʒu30𒴂Ǝ̃s[NȂ̂Ŗ
    }
    idx++;
    if (idx >= 64)
    {
      SD16CCTL0 &= ~SD16SC;             // ADϊ~
      SD16INCTL0 = SD16INTDLY_0 + SD16GAIN_1 + SD16INCH_1; // ̓`ld
      f_iv = 2;                         // ItO
      P2IFG &= ~0x1;                    // P2.0 IFG cleared
    }
  }
}


// Port 2 interrupt service routine
#pragma vector=PORT2_VECTOR
__interrupt void Port_2(void)
{
  if (idx == 0)
  {
    SD16CCTL0 |= SD16SC;                // ADϊJn
  }
  P2IFG &= ~0x1;                        // P2.0 IFG cleared
}

/***************************************
    dat = ݒް, num = \̐
    ߂l͎w茅ȉ̐
***************************************/
long disp_d(long dat, long num)
{
  if (dat / num == 0)                   // \0ǂ𒲂ׂ
  {
    if (f_0 == 0)                       // 0\Ăǂ׸ނ𒲂ׂ
    {
      OUTLCDD(' ');                     // 0\Ȃ' '\
    }
    else
    {
      OUTLCDD(0x30);                    // 0\
      f_0 = 1;
    }
  }
  else
  {
    OUTLCDD(dat / num + 0x30);          // w茅\
    f_0 = 1;                            // ȍ~0\悤f_0
  }
  return dat - ((dat / num) * num);     // w茅ȉ̐߂
}

/***********************************
  LCD̶ق1sڐ擪
***********************************/
void	HOME_LCD(void)
{
  OUTLCDC(0x80);                        // ِݒޔs
  t1ms(1);
}

/***********************************
  LCD̶ق2sڐ擪
***********************************/
void	HOME2_LCD(void)
{
  OUTLCDC(0xc0);                        // ِݒޔs
  t1ms(1);
}


/***************************************
  1ms~datԑ҂ٰ
***************************************/
void t1ms(unsigned short dat)           // Basic Timer1g
{
  unsigned short j;
  unsigned long i;

  i = (unsigned long)(32.768 * dat - 22.); // ACLK(32.768kHz)o߃JEgvZ
                                          // 22͎Ԓp(MCLK̒lŕς)
  do
  {
    j = BTCNT1;                         // j͉ʂ̃JE^l
    while(BTCNT1 == j);                 // BTCNT1JEgAbv܂ő҂
    i--;                                // iPJEg
  }while (i != 0);                      // i=0(^CAbv)܂ŌJԂ
}

/***************************************
  50usԑ҂ٰ
***************************************/
void  t50us(void)
{
  short i;
  i = 62;                               // v
  do
  {
    i--;
  } while (i != 0);
}

/*************************************************
            @LCD@֘Aٰ݁@
*************************************************/
void  LCD_INIT(void)                    //LCDӼޭق̏
{
  int i;

  LCD_RS = 0;
  LCD_E = 0;
  t1ms(200);                            // 200ms҂
  OUTLCDH(0x30);
  t1ms(20);                             // 20ms҂
  OUTLCDH(0x30);
  t1ms(20);                             // 20ms҂
  OUTLCDH(0x30);
  t1ms(20);                             // 20ms҂
  OUTLCDC(0x28);                        // 4BIT,2L,5X7 ݽ׸ݥڼ޽ւ̏
  t1ms(20);                             // 20ms҂

  OUTLCDC(0x8);                         // Display Off
  t1ms(20);                             // 20ms҂
  OUTLCDC(0x1);                         // Clear Display
  t1ms(20);                             // 20ms҂
  OUTLCDC(0x06);                        // ټ Right
  t1ms(20);                             // 20ms҂
  OUTLCDC(0xe);                         // Display On, cursol on
  t1ms(20);                             // 20ms҂
  OUTLCDC(0x80);                        // HOME
  t1ms(20);                             // 20ms҂
  for (i = 0; i < 128; i++)             // \ر
  {
    OUTLCDD(' ');
  }

  HOME_LCD();
}

void  OUTLCDH(unsigned char dat)        // ݽ׸ݥڼ޽ւ̏
{                                       // 4rbĝ
  unsigned char dd;

  LCD_RS = 0;
//	4ޯĂDB4`7ɐݒ
  dd = P2IN;                            // P2.0`P2.3Ȃ悤P2̏Ԃ擾
  dd &= 0x0f;                           // P2.4`P2.70ر
  dd |= dat & 0xf0;                     // P2.4`P2.7dat̏4ޯĂ
  P2OUT = dd;                           // PORT2ddo
  LCD_E = 1;
  LCD_E = 0;
  t50us();                              // 50us҂
}

void  OUTLCDC(unsigned char dat)        // ݽ׸ݥڼ޽ւ̏
{
  unsigned char dd;

  LCD_RS = 0;
//	4ޯĂDB4`7ɐݒ
  dd = P2IN;                            // P2.0`P2.3Ȃ悤P2̏Ԃ擾
  dd &= 0x0f;                           // P2.4`P2.70ر
  dd |= dat & 0xf0;                     // P2.4`P2.7dat̏4ޯĂ
  P2OUT = dd;                           // PORT2ddo
  LCD_E = 1;
  LCD_E = 0;
//	4ޯĂDB4`7ɐݒ
  dd = P2IN;                            // P2.0`P2.3Ȃ悤P2̏Ԃ擾
  dd &= 0x0f;                           // P2.4`P2.70ر
  dd |= dat << 4;                       // P2.4`P2.7dat̉4ޯĂ
  P2OUT = dd;                           // PORT2ddo
  LCD_E = 1;
  LCD_E = 0;
  t50us();                              // 50us҂
}

void  OUTLCDD(unsigned char dat)        // ްڼ޽ւ̏
{
  unsigned char dd;

  LCD_RS = 0;
//	4ޯĂDB4`7ɐݒ
  dd = P2IN;                            // P2.0`P2.3Ȃ悤P2̏Ԃ擾
  dd &= 0x0f;                           // P2.4`P2.70ر
  dd |= dat & 0xf0;                     // P2.4`P2.7dat̏4ޯĂ
  P2OUT = dd;                           // PORT2ddo
  LCD_RS = 1;
  LCD_E = 1;
  LCD_E = 0;
//	4ޯĂDB4`7ɐݒ
  dd = P2IN;                            // P2.0`P2.3Ȃ悤P2̏Ԃ擾
  dd &= 0x0f;                           // P2.4`P2.70ر
  dd |= dat << 4;                       // P2.4`P2.7dat̉4ޯĂ
  P2OUT = dd;                           // PORT2ddo
  LCD_E = 1;
  LCD_E = 0;
  LCD_RS = 0;
  t50us();                              // 50us҂
}

